package xlogo.gui.preferences;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import xlogo.Config;
import xlogo.Application;
import xlogo.Logo;
/**
 * Title :        XLogo
 * Description :  XLogo is an interpreter for the Logo 
 * 						programming language
 * @author Loïc Le Coq
 */
public class Preference extends JDialog implements ActionListener {
	private static final long serialVersionUID = 1L;
	private Application cadre;
	protected static Color violet = new Color(169, 169, 246);
	private JButton bouton_OK = new JButton(Logo.messages.getString("ok"));
	private JButton bouton_CANCEL = new JButton(Logo.messages.getString("annuler"));
	private JPanel panneau_bouton = new JPanel();

	private JTabbedPane jt = new JTabbedPane();
	
	private JScrollPane js_turtles=new JScrollPane();

	private Panel_General panel_General;
	private Panel_Turtles panel_Turtles;
	private Panel_Sound panel_Sound;
	private Panel_Options panel_Options;
	private Panel_Font panel_Font;
	private Panel_Highlighter panel_Highlighter;
	
	public Preference(Application cadre) {
		super(cadre);
		panel_General=new Panel_General(cadre);
		panel_Turtles=new Panel_Turtles(cadre);
		panel_Sound=new Panel_Sound(cadre);
		panel_Options=new Panel_Options(cadre);
		panel_Font=new Panel_Font(cadre);
		panel_Highlighter=new Panel_Highlighter(cadre);
		
		bouton_CANCEL.setFont(Config.police);
		bouton_OK.setFont(Config.police);
		jt.setFont(Config.police);

		this.cadre = cadre;
		try {
			jbInit();
		} catch (Exception e) {
			e.printStackTrace();
		}
		this.setModal(false);
		this.setResizable(true);
		this.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		setLocation(100,100);
	}

	private void jbInit() throws Exception {
		jt.setBackground(Color.pink);
		jt.setFont(new java.awt.Font("DialogInput", 1, 12));
		panneau_bouton.setBackground(violet);
		bouton_OK.setBackground(Color.orange);
		bouton_CANCEL.setBackground(Color.orange);
		this.getContentPane().setBackground(violet);
		this.setTitle("");
		this.getContentPane().setLayout(new BorderLayout());
		
		jt.add(panel_General, "General");

		js_turtles.getViewport().add(panel_Turtles);
		jt.add(js_turtles, Logo.messages.getString("choix_tortue"));

		jt.add(panel_Options, Logo.messages.getString("options"));
		
		jt.add(panel_Sound, Logo.messages.getString("son"));
		jt.add(panel_Font, Logo.messages.getString("police"));
		
		JScrollPane js_coloration=new JScrollPane(panel_Highlighter);
		jt.add(js_coloration, Logo.messages.getString("coloration"));
		
		getContentPane().add(jt, BorderLayout.CENTER);
		
		panneau_bouton.add(bouton_CANCEL);
		panneau_bouton.add(bouton_OK);
		getContentPane().add(panneau_bouton, BorderLayout.SOUTH);
		bouton_OK.addActionListener(this);
		bouton_CANCEL.addActionListener(this);
		setVisible(true);
		pack();
	}
	public void actionPerformed(ActionEvent e) {
		cadre.close_Preference();
		if (e.getActionCommand().equals(Logo.messages.getString("ok"))) {
			panel_General.update();
			panel_Turtles.update();
			panel_Options.update();
			panel_Sound.update();
			panel_Font.update();
			panel_Highlighter.update();
			dispose();
		} else
			dispose();
	}
}